USE AdventureWorks;

GO
CREATE PROCEDURE Sales.GetDiscountsForCategoryAndDate
@Category nvarchar(50) = NULL,
@DateToCheck datetime = NULL
AS
BEGIN
	IF @DateToCheck IS NULL SET @DateToCheck = GETDATE();
	SELECT Description, DiscountPct, Type, Category, StartDate, EndDate, MinQty, MaxQty
	FROM Sales.SpecialOffer
	WHERE Category IN (@Category) AND (@DateToCheck BETWEEN StartDate AND EndDate);
END

EXEC Sales.GetDiscountsForCategoryAndDate 'Reseller'

DECLARE @DateToCheck datetime
SET @DateToCheck = DATEADD(MONTH, 1, GETDATE())
EXEC Sales.GetDiscountsForCategoryAndDate 'Reseller', @DateToCheck